Improve socket exception message when bind() fails
06/13/2012 11:42 AM - drbrain (Eric Hodel)

Status: Closed

Priority: Normal
Assignee: akr (Akira Tanaka)
Target version: 2.6

Description

=begin

If the user tries to bind a port that is already in use the user does not receive any notification of which port (and address) failed.
When multiple connections are being made makes it difficult to determine which connection was not correctly bound.

For example, WEBrick binds both IPv4 and IPv6 sockets. If one of the ports is already bound you will receive a confusing error
message.

This patch adds the port and address to the error message:

$ cat test.rb
require 'socket’

TCPServer.new '0.0.0.0', 5900

$ make runruby

J/miniruby -L/lib -I. -l.ext/common ./tool/runruby.rb --extout=.ext -- --disable-gems ./test.rb

Jtest.rb:3:in initialize": Address already in use - bind(2) for "0.0.0.0" port 5900 (Errno::EADDRINUSE) from ./test.rb:3:in new'
from ./test.rb:3:in ™'

make: *** [runruby] Error 1

Current behavior:
$ ruby test.rb
test.rb:3:in initialize': Address already in use - bind(2) (Errno::EADDRINUSE) from test.rb:3:in new'

from test.rb:3:in ™

=end

Associated revisions

Revision d933fb2296e4ace25c5eb558be56cd23a8fcc88f - 04/06/2013 02:39 AM - akr (Akira Tanaka)

ext/socket: Improve socket exception message to show socket address.
[ruby-core:45617] [Feature #6583] proposed Eric Hodel.

ext/socket/rubysocket.h (rsock_sys_fail_host_port): Declared.
(rsock_sys_fail_path): Ditto.
(rsock_sys_fail_sockaddr): Ditto.

ext/socket/udpsocket.c (udp_connect): Use rsock_sys_fail_host_port.
(udp_bind): Ditto.
(udp_send): Ditto.

ext/socket/init.c (rsock_init_sock): Specify a string for rb_sys_fail
argument.

(make_fd_nonblock): Ditto.

(rsock_s_accept): Ditto.

ext/socket/ipsocket.c (init_inetsock_internal): Use
rsock_sys_fail_host_port.

ext/socket/socket.c (rsock_sys_fail_host_port): Defined.
(rsock_sys_fail_path): Ditto.

(rsock_sys_fail_sockaddr): Ditto.
(setup_domain_and_type): Use rsock_sys_fail_sockaddr.
(sock_connect_nonblock): Ditto.

(sock_bind): Ditto.

(sock_gethostname): Specify a string for rb_sys_fail argument.
(socket_s_ip_address_list): Ditto.

¢ ext/socket/basicsocket.c (bsock_shutdown): Specify a string for
rb_sys_fail argument.
(bsock_setsockopt): Use rsock_sys_fail_path.
(bsock_getsockopt): Ditto.
(bsock_getpeereid): Refine the argument for rb_sys_fail.

¢ ext/socket/unixsocket.c (rsock_init_unixsock): Use
rsock_sys_fail_path.
(unix_path): Ditto.
(unix_send_io): Ditto.
(unix_recv_io): Ditto.
(unix_addr): Ditto.
(unix_peeraddr): Ditto.

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@40149 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision d933fb22 - 04/06/2013 02:39 AM - akr (Akira Tanaka)

¢ ext/socket: Improve socket exception message to show socket address.
[ruby-core:45617] [Feature #6583] proposed Eric Hodel.

¢ ext/socket/rubysocket.h (rsock_sys_fail_host_port): Declared.
(rsock_sys_fail_path): Ditto.
(rsock_sys_fail_sockaddr): Ditto.

® ext/socket/udpsocket.c (udp_connect): Use rsock_sys_fail_host_port.
(udp_bind): Ditto.
(udp_send): Ditto.

e ext/socket/init.c (rsock_init_sock): Specify a string for rb_sys_fail
argument.
(make_fd_nonblock): Ditto.
(rsock_s_accept): Ditto.

ext/socket/ipsocket.c (init_inetsock_internal): Use
rsock_sys_fail_host_port.

ext/socket/socket.c (rsock_sys_fail_host_port): Defined.
(rsock_sys_fail_path): Ditto.

(rsock_sys_fail_sockaddr): Ditto.

(setup_domain_and_type): Use rsock_sys_fail_sockaddr.
(sock_connect_nonblock): Ditto.

(sock_bind): Ditto.

(sock_gethostname): Specify a string for rb_sys_fail argument.
(socket_s_ip_address_list): Ditto.

ext/socket/basicsocket.c (bsock_shutdown): Specify a string for
rb_sys_fail argument.

(bsock_setsockopt): Use rsock_sys_fail_path.
(bsock_getsockopt): Ditto.

(bsock_getpeereid): Refine the argument for rb_sys_fail.

ext/socket/unixsocket.c (rsock_init_unixsock): Use
rsock_sys_fail_path.

(unix_path): Ditto.

(unix_send_io): Ditto.

(unix_recv_io): Ditto.

(unix_addr): Ditto.

(unix_peeraddr): Ditto.

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@40149 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 07/04/2012 11:07 AM - drbrain (Eric Hodel)
- File socket.improve_bind_error.2.patch added

This updated patch adds three new methods rsock_sys_fail_host_port, rsock_sys_fail_path and rsock_sys_fail_sockaddr for raising exceptions from
more than bind().

Additionally, rb_sys_fail() calls were audited and names of system calls were added where they were missing, and updated where incomplete (lacking
manual page designator).

#2 - 07/14/2012 06:41 PM - akr (Akira Tanaka)

- Assignee set to akr (Akira Tanaka)

#3 - 07/14/2012 06:43 PM - mame (Yusuke Endoh)

- Status changed from Open to Assigned

#4 - 10/28/2012 11:37 PM - akr (Akira Tanaka)

- Target version changed from 2.0.0 to 2.6

#5 - 04/06/2013 11:39 AM - akr (Akira Tanaka)
- Status changed from Assigned to Closed

- % Done changed from 0 to 100

This issue was solved with changeset r40149.
Eric, thank you for reporting this issue.

Your contribution to Ruby is greatly appreciated.
May Ruby be with you.

e ext/socket: Improve socket exception message to show socket address.
ruby-core:45617] [Feature #6583] proposed Eric Hodel.

e ext/socket/rubysocket.h (rsock_sys_fail_host_port): Declared.
(rsock_sys_fail_path): Ditto.
(rsock_sys_fail_sockaddr): Ditto.

e ext/socket/udpsocket.c (udp_connect): Use rsock_sys_fail_host_port.
(udp_bind): Ditto.
(udp_send): Ditto.

¢ ext/socket/init.c (rsock_init_sock): Specify a string for rb_sys_fail
argument.
(make_fd_nonblock): Ditto.
(rsock_s_accept): Ditto.

ext/socket/ipsocket.c (init_inetsock_internal): Use
rsock_sys_fail_host_port.

ext/socket/socket.c (rsock_sys_fail_host_port): Defined.
(rsock_sys_fail_path): Ditto.

(rsock_sys_fail_sockaddr): Ditto.

(setup_domain_and_type): Use rsock_sys_fail_sockaddr.
(sock_connect_nonblock): Ditto.

(sock_bind): Ditto.

(sock_gethostname): Specify a string for rb_sys_fail argument.
(socket_s_ip_address_list): Ditto.

ext/socket/basicsocket.c (bsock_shutdown): Specify a string for
rb_sys_fail argument.

(bsock_setsockopt): Use rsock_sys_fail_path.
(bsock_getsockopt): Ditto.

(bsock_getpeereid): Refine the argument for rb_sys_fail.

ext/socket/unixsocket.c (rsock_init_unixsock): Use
rsock_sys_fail_path.

(unix_path): Ditto.

(unix_send_io): Ditto.

(unix_recv_io): Ditto.

(unix_addr): Ditto.

(unix_peeraddr): Ditto.
bugs.ruby-lang.org/issues/6583
https://bugs.ruby-lang.org/issues/6583

Files

socket.improve_bind_error.patch 5.3 KB 06/13/2012 drbrain (Eric Hodel)
socket.improve_bind_error.2.patch 12.7 KB 07/04/2012 drbrain (Eric Hodel)
